#ifndef  _24LC256_EEPROM_H
#define  _24LC256_EEPROM_H
//------------------------------------------------------------------------------
#include "I2C.h"
#define  WRITE_CMD    0xA0
#define  READ_CMD     0xA1
#define  BUSY         1
//------------------------------------------------------------------------------
void EEPROM_init(void);
void EEPROM_write( unsigned int address , char data );
unsigned char EEPROM_read( unsigned int address );
void EEPROM_wait(void);
//------------------------------------------------------------------------------
void EEPROM_init()
{
  I2C_init(100000);
}

void EEPROM_write( unsigned int address , char data )
{
  I2C_start();

  EEPROM_wait();
  I2C_write( address>>8 );        //Higher Byte
  I2C_write( address );           //Lower Byte
  I2C_write( data );

  I2C_stop();
}
//------------------------------------------------------------------------------
unsigned char EEPROM_read( unsigned int address )
{
  unsigned char Byte = 0;

  I2C_start();

  EEPROM_wait();
  I2C_write(address>>8);       //Higher Byte
  I2C_write(address);          //Lower Byte
  I2C_restart();
  I2C_write(READ_CMD);
  Byte = I2C_read(NACK);                             //Give NACK to stop reading

  I2C_stop();

  return Byte;
}
//------------------------------------------------------------------------------
void EEPROM_wait()
{
  while( I2C_write(WRITE_CMD) == BUSY )                 //Wait until device is free
  {
    I2C_restart();
  }
}
//------------------------------------------------------------------------------
#endif